<!--- TO DO --->
<!--- 
clean up fieldset displays
make links more obvious
set demo vars 
write explanation
blog
cfswitch
cftry.errormessage
--->
<!--- the time out setting --->
<cfsetting requesttimeout="10000">
<!--- param for error messages --->
<cfparam name="errorMessage" default="">
<cfparam name="url.verity" default="0">
<cfparam name="url.search" default="0">
<cfparam name="url.starturl" default="">
<cfparam name="url.verityname" default="">
<cfparam name="form.searchString" default="">
<cfparam name="form.verityName" default="">
<cfparam name="demoMode" default="1">

<!--- set up demo restrictions --->
<cfif NOT cgi.SERVER_NAME contains 'mredesign'>
<cfset demoMode = 0>
</cfif>

<!--- set up variables for action --->
<cfset action = 'start'>
<cfset legendText = '1. Create a Site Map'>
<cfif isdefined('form.ini_root')>
<cfset action = 'runxml'>
<cfset legendText = '2. Review Your Site Map'>
</cfif>
<cfif url.verity is 1 and url.search is 0>
<cfset action = 'runverity'>
<cfset legendText = '3. Create Verity Search'>
</cfif>
<cfif url.search is 1>
<cfset action = 'search'>
<cfset legendText = '4. Search Your Collection'>
</cfif>

<!--- set up showing errors --->
<cfif errorMessage neq ''>
<cfset action = 'error'>
<cfset legendText = 'Error!'>
</cfif>

<!--- output area --->
<fieldset><legend><cfoutput>#legendText#</cfoutput></legend>
<!--- start over link --->
<cfif action neq 'start'>
<cfoutput>
<p style="float:right; width:120px;">( <a href="#cgi.SCRIPT_NAME#">Start Over</a> )</p>
</cfoutput>
</cfif>
<!--- switch for action --->
<cfswitch expression="#action#">

<!--- 1) CREATE SITE MAP --->
<cfcase value="start">
<!--- First a form to submit our info --->
<cfif NOT isdefined('form.fieldnames')>
<!--- if the setup form has not been submitted --->
<cfoutput>
<p>Enter the URL to start the index with, and the start page file name (index.html, default.php, whatever). <br />Go easy on the max levels - too deep gets slow and heavy. Suggest: try 2 at first and see what results you get, you can always run it again.<br />
<br />
The URL to Submit is the location of your finished site map, which will be submitted to Google <br />
(suggest: http://#cgi.SERVER_NAME#/sitemap.xml). <br />
Leave it blank to skip submitting the sitemap for now. <br />
<br />
Click submit.... and be patient while your XML site map is created... <br /></p>
<cfif demoMode is 1>
<p><em><strong>NOTE: Limited to 1 level and no submission for demo</strong></em><br /></p>
</cfif>
<form name="vsForm" id="vsForm" method="post" action="#cgi.SCRIPT_NAME#">
<label for="ini_root">Sitemap Root (full url)</label>
<input type="text" name="ini_root" size="35" value="http://#cgi.SERVER_NAME#"/>
<br />
<label for="ini_startPage">Start Page</label>
<input type="text" name="ini_startPage" size="35" value="index.cfm"/>
<br />
<label for="ini_levelMax">Max Level to Crawl</label>
<!--- limited to 1 for demo --->
<cfif demoMode is 1>
<input type="text" readonly="readonly" name="ini_levelMax" size="2" value="1" maxlength="1" />
<cfelse>
<input type="text" name="ini_levelMax" size="2" value="2" maxlength="1" /> 
</cfif>
<br />
<label for="ini_sitemap">Sitemap URL to Submit</label>
<!--- disabled for demo --->
<cfif demoMode is 1>
<input type="text" name="ini_sitemap" size="35" readonly="readonly" value="" />
<cfelse>
<input type="text" name="ini_sitemap" size="35" value="" /> 
</cfif>
<p style="text-align:center">
&bull;&bull;&bull;&nbsp;
<input type="submit" value="submit" name="vsSubmit" class="button">
&nbsp;&bull;&bull;&bull;
</p>
</form>
</cfoutput>
</cfif>
</cfcase>

<!--- 2) CREATE AND SHOW SITE MAP --->
<cfcase value="runxml">
<!--- catch errors --->
<cftry>
<!--- set the sitemap creation vars --->
<cfset ini_root="#form.ini_root#" />
<cfset ini_startPage="#form.ini_startPage#" />
<cfset ini_levelMax=#form.ini_levelMax# />
<cfset ini_sitemap="#form.ini_sitemap#" />  
<!--- run the sitemap cfc --->
<!--- create a query --->
<cfinvoke component="_sitemap" method="sitemap" returnvariable="qry_sitemap" root="#ini_root#" url="#ini_startPage#" depthMax="#ini_levelMax#">
<!--- index the site --->
<cfinvoke component="_sitemap" method="indexIt" returnvariable="qry_sitemapIndex" root="#ini_root#" query="#qry_sitemap#">
<!--- create sitemap content --->
<cfinvoke component="_sitemap" method="googleSitemap" returnvariable="sitemap" root="#ini_root#" query="#qry_sitemap#">
<!--- submit sitemap if url given --->
<cfif len(trim(ini_sitemap)) gt 12 >
<cfinvoke component="_sitemap" method="submitSitemap" url="#ini_sitemap#" returnvariable="qry_sitemap" >
</cfif>
<!--- set up the sitemap content as a variable --->
<cfset siteMapPath = "#GetDirectoryFromPath(GetCurrentTemplatePath())#sitemap.xml" />
<cfset siteMapLink = "sitemap.xml" />
<!--- write the sitemap file --->
<cffile
action = "write"
file = "#siteMapPath#"
output = "#sitemap#"
addNewLine = "no" 
charset = "utf-8">
<!--- handle any errors --->
<cfcatch type="any">
<cfset errorMessage = "Oops. Something's not quite right... ">
</cfcatch>
</cftry>
<!--- SHOW OUTPUT --->
<!--- set the sitemap url --->
<cfset startUrl = "http://#cgi.SERVER_NAME##cgi.SCRIPT_NAME#">
<cfset startUrl = listDeleteAt(startUrl, listlen(startURL, '/'), '/')>
<cfset startUrl = "#startUrl#/sitemap.xml">
<!---  show happy message --->
<cfoutput>
<p>
<strong>Your Sitemap is Ready!</strong>
<br />
<br />
Look over the code that was created ( <a href="##showxml"><strong>see below</strong></a>, or <a href="sitemap.xml" target="_blank"><strong>open the xml file</strong></a> ).
<br />
<br />
<strong><a href="#cgi.script_name#?verity=1&startUrl=#urlencodedformat(startUrl)#">&bull;&bull;&bull;&nbsp;Set up a Verity Collection&nbsp;&bull;&bull;&bull;</a></strong>
<br />
or <a href="#cgi.script_name#">return to the setup screen</a> to change settings.<br />
</p>
<!--- show settings that were used --->
<p>
<a name="showxml"></a>
<br />
<strong>Here is your sitemap:</strong>
<br /><br />Indexing: #ini_root#
<br />Crawling: #ini_levelMax# Level<cfif ini_levelMax neq 1>s</cfif>
<br />Included: #qry_siteMap.recordCount# Links
<br />
</p>
<!--- show sitemap xml code in textarea container --->
<form>
<textarea id="showCode" style="width:100%; height:260px">
<cfoutput>#siteMap#</cfoutput>
</textarea>
</form>
<br />
<!--- link to the xml file --->
<p><a href="sitemap.xml" target="_blank">View the generated XML file (new window)</a></p>
</cfoutput>
<!--- dump the sitemap query info for quick review --->
<cfoutput>
<br />
<br />
<p><strong>CFDUMP var=&quot;##qry_sitemap##&quot;</strong></p>
<!--- get query --->
<cfdump var="#qry_sitemap#">
</cfoutput>
</cfcase>
<!--- / END 2 --->

<!--- 3) MAKE VERITY COLLECTION --->
<cfcase value="runverity">
<!--- if verity form has not been submitted --->
<cfif form.verityName eq ''>
<!--- show form for verity collection --->
<cfoutput>
<p>Enter the name for your verity collection, verify the sitemap url is correct, <br />
then click submit, and wait...<br /></p>
<cfif demoMode is 1>
<p><em><strong>NOTE: custom collection name restricted for demo</strong></em><br /></p>
</cfif>
<form name="vcForm" id="vcForm" method="post" action="#cgi.SCRIPT_NAME#?verity=1&startUrl=#url.startUrl#">
<label for="verityName">Verity Collection Name</label>
<!--- set name for collection --->
<cfif demoMode eq 1>
<input type="text" name="verityName" readonly="readonly" size="35" value="sampleCollection"/>
<cfelse>
<input type="text" name="verityName" size="35" value=""/> 
</cfif>
<br />
<label for="siteMapURL">Site Map URL</label>
<input type="text" name="siteMapURL" size="55" value="#urldecode(url.starturl)#"/>
<br />
<p style="text-align:center">
&bull;&bull;&bull;&nbsp;
<input type="submit" value="submit" name="vcSubmit" class="button" />
&nbsp;&bull;&bull;&bull;
</p>
</form>
<br />
</cfoutput>
<!--- if the form verity name is defined --->
<cfelse>
<!--- run the verity creation file --->
<cfinclude template="_verity.cfm">
<!--- show results from verity action --->
<cfoutput>
<p>
<strong>Indexing Complete!</strong>
</p>
<p>
<strong><a href="#cgi.SCRIPT_NAME#?search=1&verityName=#form.verityName#" class="actionLink">&bull;&bull;&bull;&nbsp;Run a Sample Search&nbsp;&bull;&bull;&bull;</a></strong>
</p>
<cfif demoMode is 1>
<p>
<em><strong>NOTE: limited to 10 links for demo</strong></em>
</p>
</cfif>
<p>
Collection Name: #form.verityName#<br />
#info.recordCount# Documents Indexed, Time: #(totaltime / 1000)# Seconds<br />
</p>
</cfoutput>
<!--- dump verity query (set for demo only, this could get huge in real use!) --->
<cfif demoMode eq 1>
<p><strong>cfdump var=&quot;#info#&quot;</strong></p>
<cfdump var="#info#">
</cfif>
</cfif>
</cfcase>
<!--- / END 3 --->

<!--- 4) SEARCH --->
<cfcase value="search">
<!--- make sure we have the collection name and a search term --->
<cfif url.verityName neq '' AND trim(form.searchString) neq ''>
<!--- lock the search to avoid hitting verity while it's updating --->
<cftry>
<cflock name="searchLock" type="readonly" timeout="1" throwontimeout="Yes">
<cftry>
<cfsearch name="sampleSearch" collection="#url.verityname#" criteria="#form.searchString#"  />
<cfcatch type="Any">
<cfset errorMessage = "The search criteria you entered contains invalid characters and/or parameters. Please <a href='javascript:history.back()'>try another search</a>">
</cfcatch>
</cftry>
</cflock>
<cfcatch type="Lock">
<cfset errorMessage = "The search index is updating. <br /> Please <a href='javascript:history.back()'>try again</a> in a few minutes">
</cfcatch>
</cftry>
<!--- show the results --->
<cfoutput>
<cfif demoMode eq 1>
<p>The verity search results are returned as a query, which allows for all sorts of formatting and conditional display. <a href="http://www.coldfusionguy.com/ColdFusion/blog/index.cfm/2007/11/30/Populating-a-Verity-Index-From-Your-Site-Map">Scott Bennett</a> posted <a href="http://www.coldfusionguy.com/ColdFusion/blog/index.cfm/2007/11/30/Populating-a-Verity-Index-From-Your-Site-Map">a really neat trick</a> to limit the sections of your page that verity can see when indexing, so that your search summaries match what is seen visibly on the page.
<br />
Ray Camden's <a href="http://www.coldfusionjedi.com/index.cfm/2007/9/17/Using-Sitemaps-with-Verity">verity creation code</a> parses and digests each of the meta tags in your page, which could be used to put search-specific tags into each page of your site.
</p>
</cfif>
<p><strong>You searched for: &quot;#form.searchString#&quot;</strong>
<br />
#sampleSearch.recordCount# results found<br />
<br />
<strong><a href="#cgi.SCRIPT_NAME#?verityName=#url.verityname#&search=1">&bull;&bull;&bull;&nbsp;Try another search&nbsp;&bull;&bull;&bull;</a></strong>
<br />
</p>
</cfoutput>
<!--- if we didn't get anything --->
<cfif sampleSearch.RecordCount is 0>
<p style="text-align:center">
<br /><br />
<strong>No search match found</strong>
<br /><br />
<a href="javascript:history.back()">Return to previous page</a>
<br /><br />
<br />
</p>
<cfelse>
<!--- if we did find a match --->
<table id="searchResults">
<!--- display results --->
<cfoutput query="sampleSearch">
<tr valign="top">
<td>
<!--- file name with the link returning the file --->
<!--- HREF to file is produced using either FILE protocol
or HTTP, depending on whether this is a Web document.
so, well look at the file extension --->
<cfset FileName=GetFileFromPath(Key)>
<cfset Ext=ListLast(FileName, ".")>
<!--- display title if there is one, else filename --->
<cfif Trim(Title) IS "">
<cfset display=GetFileFromPath(Key)>
<cfelse>
<cfset display=title>
</cfif>
<!--- show the link --->
<cfif len(display) gt 75>
<cfset display = "#left(display, 85)#...">
</cfif>
<p><strong><a href="#url#">#display#</a></strong>
<br />
<strong><a href="#url#">#url#</a></strong>
<br />
#Summary#
</p>
</td>
</tr>
</cfoutput>
</table>
</cfif>
<!--- if search string is empty --->
<cfelse>
<!--- show a search form --->
<cfoutput>
<cfif demoMode eq 1>
<p>
<em><strong>NOTE: limited to 10 links for demo</strong></em>
</p>
</cfif>
<form name="searchForm" action="#cgi.SCRIPT_NAME#?#cgi.QUERY_STRING#" method="post">
<label>Search Term</label>
<input type="text" size="25" name="searchString" id="searchString" />
<p style="text-indent:120px;">Search for * to see all results returned</p>
<p style="text-align:center">
&bull;&bull;&bull;&nbsp;
<input type="submit" value="submit"  class="button"/>&nbsp;&bull;&bull;&bull;
</p>
</form>
</cfoutput>
<br />
</cfif>
</cfcase>
<!--- / END 4 --->

<!--- ERROR --->
<cfcase value="error">
<br />
<br />
<cfoutput>
<p><strong>#errormessage#</strong></p>
</cfoutput>
</cfcase>
</cfswitch>

</fieldset>